# coding: utf-8

"""
    SendPost API

    Email API and SMTP relay to not just send and measure email sending, but also alert and optimise. We provide you with tools, expertise and support needed to reliably deliver emails to your customers inboxes on time, every time.  # noqa: E501

    The version of the OpenAPI document: 1.0.0
    Contact: hello@sendpost.io
    Generated by: https://openapi-generator.tech
"""

from datetime import date, datetime  # noqa: F401
import decimal  # noqa: F401
import functools  # noqa: F401
import io  # noqa: F401
import re  # noqa: F401
import typing  # noqa: F401
import typing_extensions  # noqa: F401
import uuid  # noqa: F401

import frozendict  # noqa: F401

from sendpost_python_sdk import schemas  # noqa: F401


class EventMetadata(
    schemas.DictSchema
):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """


    class MetaOapg:
        
        class properties:
            clickedURL = schemas.StrSchema
        
            @staticmethod
            def device() -> typing.Type['Device']:
                return Device
        
            @staticmethod
            def geo() -> typing.Type['City']:
                return City
        
            @staticmethod
            def os() -> typing.Type['Os']:
                return Os
            smtpCode = schemas.Int64Schema
            smtpDescription = schemas.StrSchema
        
            @staticmethod
            def userAgent() -> typing.Type['UserAgent']:
                return UserAgent
            __annotations__ = {
                "clickedURL": clickedURL,
                "device": device,
                "geo": geo,
                "os": os,
                "smtpCode": smtpCode,
                "smtpDescription": smtpDescription,
                "userAgent": userAgent,
            }
    
    @typing.overload
    def __getitem__(self, name: typing_extensions.Literal["clickedURL"]) -> MetaOapg.properties.clickedURL: ...
    
    @typing.overload
    def __getitem__(self, name: typing_extensions.Literal["device"]) -> 'Device': ...
    
    @typing.overload
    def __getitem__(self, name: typing_extensions.Literal["geo"]) -> 'City': ...
    
    @typing.overload
    def __getitem__(self, name: typing_extensions.Literal["os"]) -> 'Os': ...
    
    @typing.overload
    def __getitem__(self, name: typing_extensions.Literal["smtpCode"]) -> MetaOapg.properties.smtpCode: ...
    
    @typing.overload
    def __getitem__(self, name: typing_extensions.Literal["smtpDescription"]) -> MetaOapg.properties.smtpDescription: ...
    
    @typing.overload
    def __getitem__(self, name: typing_extensions.Literal["userAgent"]) -> 'UserAgent': ...
    
    @typing.overload
    def __getitem__(self, name: str) -> schemas.UnsetAnyTypeSchema: ...
    
    def __getitem__(self, name: typing.Union[typing_extensions.Literal["clickedURL", "device", "geo", "os", "smtpCode", "smtpDescription", "userAgent", ], str]):
        # dict_instance[name] accessor
        return super().__getitem__(name)
    
    
    @typing.overload
    def get_item_oapg(self, name: typing_extensions.Literal["clickedURL"]) -> typing.Union[MetaOapg.properties.clickedURL, schemas.Unset]: ...
    
    @typing.overload
    def get_item_oapg(self, name: typing_extensions.Literal["device"]) -> typing.Union['Device', schemas.Unset]: ...
    
    @typing.overload
    def get_item_oapg(self, name: typing_extensions.Literal["geo"]) -> typing.Union['City', schemas.Unset]: ...
    
    @typing.overload
    def get_item_oapg(self, name: typing_extensions.Literal["os"]) -> typing.Union['Os', schemas.Unset]: ...
    
    @typing.overload
    def get_item_oapg(self, name: typing_extensions.Literal["smtpCode"]) -> typing.Union[MetaOapg.properties.smtpCode, schemas.Unset]: ...
    
    @typing.overload
    def get_item_oapg(self, name: typing_extensions.Literal["smtpDescription"]) -> typing.Union[MetaOapg.properties.smtpDescription, schemas.Unset]: ...
    
    @typing.overload
    def get_item_oapg(self, name: typing_extensions.Literal["userAgent"]) -> typing.Union['UserAgent', schemas.Unset]: ...
    
    @typing.overload
    def get_item_oapg(self, name: str) -> typing.Union[schemas.UnsetAnyTypeSchema, schemas.Unset]: ...
    
    def get_item_oapg(self, name: typing.Union[typing_extensions.Literal["clickedURL", "device", "geo", "os", "smtpCode", "smtpDescription", "userAgent", ], str]):
        return super().get_item_oapg(name)
    

    def __new__(
        cls,
        *_args: typing.Union[dict, frozendict.frozendict, ],
        clickedURL: typing.Union[MetaOapg.properties.clickedURL, str, schemas.Unset] = schemas.unset,
        device: typing.Union['Device', schemas.Unset] = schemas.unset,
        geo: typing.Union['City', schemas.Unset] = schemas.unset,
        os: typing.Union['Os', schemas.Unset] = schemas.unset,
        smtpCode: typing.Union[MetaOapg.properties.smtpCode, decimal.Decimal, int, schemas.Unset] = schemas.unset,
        smtpDescription: typing.Union[MetaOapg.properties.smtpDescription, str, schemas.Unset] = schemas.unset,
        userAgent: typing.Union['UserAgent', schemas.Unset] = schemas.unset,
        _configuration: typing.Optional[schemas.Configuration] = None,
        **kwargs: typing.Union[schemas.AnyTypeSchema, dict, frozendict.frozendict, str, date, datetime, uuid.UUID, int, float, decimal.Decimal, None, list, tuple, bytes],
    ) -> 'EventMetadata':
        return super().__new__(
            cls,
            *_args,
            clickedURL=clickedURL,
            device=device,
            geo=geo,
            os=os,
            smtpCode=smtpCode,
            smtpDescription=smtpDescription,
            userAgent=userAgent,
            _configuration=_configuration,
            **kwargs,
        )

from sendpost_python_sdk.model.city import City
from sendpost_python_sdk.model.device import Device
from sendpost_python_sdk.model.os import Os
from sendpost_python_sdk.model.user_agent import UserAgent
